package com.github.dtschust.zork;

import java.util.EnumSet;
import java.util.Optional;

public enum ZorkTriggerType {
    SINGLE("single"),
    PERMANENT("permanent");

    private final String name;

    ZorkTriggerType(final String name) {
        this.name = name;
    }

    public static Optional<ZorkTriggerType> fromName(final String name) {
        return EnumSet.allOf(ZorkTriggerType.class).stream().filter(e -> e.name.equals(name)).findAny();
    }
}
